// -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil;c-basic-offset: 2 -*-

const preferencesNVService = NVservice.PS.getBranch("");
//gBrowser = document.getElementById("content");


var NVid = new Date(); NVid = NVid.toUTCString();
var NVlastAction = "";

todoFirst();

function todoFirst () { 
  dump("LOAD\n");
  NVfile.init();

  window.removeEventListener("close", NVonClose, true);
  window.addEventListener("close", NVonClose, true);

  window.removeEventListener("load", NVonLoad, true);
  window.addEventListener("load", NVonLoad, true);

  window.removeEventListener("focus", NVonFocus, true);
  window.addEventListener("focus", NVonFocus, true);
  
  //window.addEventListener("click", NVonClick, true);
  //window.addEventListener("blur", NVonBlur, true);
  dump("LOADED\n");
}


function NVonClick(event) { dump("click : " + event + "\n"); }


function NVonFocus(event) { 
  window.removeEventListener("focus", NVonFocus, true);  
  window.addEventListener("blur", NVonBlur, true); 
  //dump("focus : " + document.getElementById("content").webNavigation.currentURI.spec +"\n");
 
  id = preferencesNVService.getCharPref("navtracer.lastwindowseen");
  // dump("window id : " + NVid + " " + id +"\n" );
  if (id != NVid) {
    dump("window change \n" );
    NVfile.writeToFile("window-change", new Date(), "", "", "");
  }  
}
  

function NVonBlur(event) { 
  window.removeEventListener("blur", NVonBlur, true);
  window.addEventListener("focus", NVonFocus, true); 
  //dump("blur : " + document.getElementById("content").webNavigation.currentURI.spec +"\n");
  preferencesNVService.setCharPref("navtracer.lastwindowseen", NVid);
}


function NVonLoad(event) {
  if (!NVBrowserProgressListener.QueryInterface(Components.interfaces.nsIWebProgressListener).listened) {
    document.getElementById("content").addProgressListener(NVBrowserProgressListener); 
    document.getElementById("content").addEventListener("unload", NVonUnload, true);
    NVBrowserProgressListener.QueryInterface(Components.interfaces.nsIWebProgressListener).listened = true;
    dump("New window\n");
  }
  else {
/*
    dump('original target ' + event.originalTarget.baseURI + '\n');
    dump('original target ' + event.originalTarget.title + '\n');
    dump('original target ' + event.originalTarget.referrer + '\n');
    NVonLoad(document.getElementById("content").webNavigation.currentURI);
*/
    NVpageData(event.originalTarget);
  }
  window._content.document.location.navtracer = "navtracer";
}


function NVonTabChange (aLocation) {
     var title = window._content.document.title;
     var href = window._content.document.location.href;
     var referrer = window._content.document.referrer;
     if (NVlastAction != "") {
       var unloadInfo = NVlastAction.split(",");
       NVfile.writeToFile("tabclose", unloadInfo[1], unloadInfo[2], unloadInfo[3], "");
       dump("Tab close \n");
     }
     
     dump("Tab change : \n");
     dump("-> Title " + title  + "\n");
     dump("-> Url " + href  + "\n");
     dump("-> Referrer " + referrer + "\n");
     
     NVfile.writeToFile("tabchange", new Date(), title.replace(/,/g," "), href, referrer);
     NVlastAction = "";
};


function NVpageData (document) {
     dump("Page load : \n");
     var title = document.title;
     var href =  document.baseURI;
     var referrer = document.referrer;
     dump("-> Title " + document.title  + "\n");
     dump("-> Url " + document.baseURI  + "\n");
     dump("-> Referrer " + document.referrer + "\n");
     NVfile.writeToFile("pageload", new Date(), title.replace(/,/g," "), href, referrer);
     NVlastAction = "";
}


function NVonUnload(event) {
  var e = event;
  var title = event.originalTarget.title;
  var url = event.originalTarget.baseURI;
  if (url == "chrome://browser/content/browser.xul") {
    dump("tabclose\n")
    title = event.target.mCurrentTab.label;
    url = event.target.selectedBrowser.lastURI.spec;
  }
  dump("page unload : \n");
  dump('-> Title ' + title + '\n');
  dump('-> Url ' + url + '\n');
  NVfile.writeToFile("unload", new Date(), title.replace(/,/g," ") , url, "");
  NVlastAction = "unload," + new Date() +", " + title.replace(/,/g," ") +", " + url;
}


function NVonClose(event) {
  dump("window close (onunload) : " + document.getElementById("content").webNavigation.currentURI.spec +"\n");
  NVfile.writeToFile("window-close", new Date(), "","","");
  NVfile.clear();
}
